=== modified file 'NEWS'
--- NEWS	2006-09-21 17:00:00 +0000
+++ NEWS	2006-09-21 19:41:29 +0000
@@ -37,6 +37,8 @@
 
   BUG FIXES:
 
+    * Don't abort when annotating empty files (John Arbash Meinel, #56814)
+
     * Raise WeaveFormatError rather than StopIteration when trying to read
       an empty Weave file. (John Arbash Meinel, #46871)
 

=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2006-06-20 03:57:11 +0000
+++ bzrlib/annotate.py	2006-09-21 19:41:29 +0000
@@ -39,7 +39,10 @@
 
     prevanno=''
     annotation = list(_annotate_file(branch, rev_id, file_id))
-    max_origin_len = max(len(origin) for origin in set(x[1] for x in annotation))
+    if len(annotation) == 0:
+        max_origin_len = 0
+    else:
+        max_origin_len = max(len(origin) for origin in set(x[1] for x in annotation))
     for (revno_str, author, date_str, line_rev_id, text ) in annotation:
         if verbose:
             anno = '%5s %-*s %8s ' % (revno_str, max_origin_len, author, date_str)

=== modified file 'bzrlib/tests/blackbox/test_annotate.py'
--- bzrlib/tests/blackbox/test_annotate.py	2006-08-24 00:21:44 +0000
+++ bzrlib/tests/blackbox/test_annotate.py	2006-09-21 19:41:29 +0000
@@ -97,3 +97,13 @@
         self.assertEquals(out, '')
         self.assertEquals(err, 'bzr: ERROR: bzr annotate --revision takes'
                                ' exactly 1 argument\n')
+
+    def test_annotate_empty_file(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree_contents([('tree/empty', '')])
+        tree.add('empty')
+        tree.commit('add empty file')
+
+        os.chdir('tree')
+        out, err = self.run_bzr('annotate', 'empty')
+        self.assertEqual('', out)

